jQuery(document).ready(function($){
	jQuery('form.ticket-form').mousedown( function() {
	    tinyMCE.triggerSave();
	});	
	jQuery('form#ticket_save_settings').mousedown( function() {
	    tinyMCE.triggerSave();
	});		
	$('form#createticket select.department').change(function(){
		var department_id = $('form#createticket select[name="department"]').val();
		if(department_id>0){
			jQuery.ajax({
				type:'POST',
				data:'action=department_get_helptopic&department_id='+department_id,
				url:ajaxurl,
				beforeSend:function(){
					$('form#createticket div.helptopics').remove();
					$('img#icon_loading').show();
				},
				success:function(data){
					if(data!=''){
						$('div.department').append(data);
					}
					$('img#icon_loading').hide();
				}
			});
			return false;
		}
		else{
			return;
		}
	});
	$('form#createticket').submit(function(){
		var data_form = $(this).serialize();
		jQuery.ajax({
			type:'POST',
			data:data_form,
			url:wpo_ticket_ajax_url,
			beforeSend:function(){
				$('div.alert').removeClass('alert-error');
				$('div.alert').removeClass('alert-success');
				$('div.alert').hide();
				$('form#createticket button[type="submit"]').attr('disabled','disabled');
				$('form#createticket button[type="submit"]').text('Processing ...');
			},
			success:function(data){
				var data = $.parseJSON(data);
				if(data.resp=='error'){
					$('div.alert').addClass('alert-error');
					$('div.alert').html(data.mess);
					$('div.alert').slideDown();
					if($.fn.reload !== undefined) {
					    // marquee is loaded and available
						Recaptcha.reload();
					}					
				}
				else{
					window.location.href=data.url_ticket;
				}
				$('form#createticket button[type="submit"]').removeAttr('disabled');
				$('form#createticket button[type="submit"]').text('Open Ticket');
			}
		});
		return false;
	});
	$('form#replyticket').submit(function(){
		var data_form = $(this).serialize();
		jQuery.ajax({
			type:'POST',
			data:data_form,
			url:wpo_ticket_ajax_url,
			beforeSend:function(){
				$('div.alert').removeClass('alert-error');
				$('div.alert').removeClass('alert-success');
				$('div.alert').hide();
				$('form#replyticket button[type="submit"]').attr('disabled','disabled');
				$('form#replyticket button[type="submit"]').text('Processing ...');
			},
			success:function(data){
				var data = $.parseJSON(data);
				if(data.resp!="success"){
					$('div.alert').addClass('alert-error');
					$('div.alert').html(data.mess);
					$('div.alert').slideDown();
				}
				else{
					window.location.href=data.url_ticket;
				}
				$('form#replyticket button[type="submit"]').removeAttr('disabled');
				$('form#replyticket button[type="submit"]').text('Response');
			}
		});
		return false;
	});
	$('button#reply_ticket').click(function(){
		$('form#replyticket').slideDown();
		$('button#reply_ticket').hide();
	});
	$('select.ticket_status').change(function(){
		var post_id = $(this).attr('post_id');
		var act = $(this).val();
		jQuery.ajax({
			type:'POST',
			data:'post_id='+post_id+'&action=admin_action_ticket_status&act='+act,
			url:ajaxurl,
			beforeSend:function(){
				$('span.waiting-'+post_id).show();
			},
			success:function(data){
				var data = $.parseJSON(data);
				if(data.resp=='success'){
					$('span.waiting-'+post_id).hide();
				}
			}		
		});
		return false;
	});
	$('input.allow_ticket').change(function(){
		var user_id = $(this).attr('user_id');
		if ($(this).is(':checked')) {
			var value='yes';
		}
		else{
			var value='no';
		}
		jQuery.ajax({
			type:'POST',
			data:'user_id='+user_id+'&action=allow_ticket&value='+value,
			url:ajaxurl,
			beforeSend:function(){
				$('span.allow_ticket_waiting_'+user_id).show();
			},			
			success:function(data){
				$('span.allow_ticket_waiting_'+user_id).hide();
			}			
		});
		return false;
	});
	$('input.allow_upload_files').change(function(){
		var user_id = $(this).attr('user_id');
		if ($(this).is(':checked')) {
			var value='yes';
		}
		else{
			var value='no';
		}
		jQuery.ajax({
			type:'POST',
			data:'user_id='+user_id+'&action=allow_upload_files&value='+value,
			url:ajaxurl,
			beforeSend:function(){
				$('span.allow_upload_files_waiting_'+user_id).show();
			},			
			success:function(data){
				$('span.allow_upload_files_waiting_'+user_id).hide();
			}			
		});
		return false;
	});
	$('input.allow_update_ticket').change(function(){
		var user_id = $(this).attr('user_id');
		if ($(this).is(':checked')) {
			var value='yes';
		}
		else{
			var value='no';
		}
		jQuery.ajax({
			type:'POST',
			data:'user_id='+user_id+'&action=allow_update_ticket&value='+value,
			url:ajaxurl,
			beforeSend:function(){
				$('span.allow_update_ticket_waiting_'+user_id).show();
			},			
			success:function(data){
				$('span.allow_update_ticket_waiting_'+user_id).hide();
			}			
		});
		return false;
	});
	$('input.allow_delete_ticket').change(function(){
		var user_id = $(this).attr('user_id');
		if ($(this).is(':checked')) {
			var value='yes';
		}
		else{
			var value='no';
		}
		jQuery.ajax({
			type:'POST',
			data:'user_id='+user_id+'&action=allow_delete_ticket&value='+value,
			url:ajaxurl,
			beforeSend:function(){
				$('span.allow_delete_ticket_waiting_'+user_id).show();
			},			
			success:function(data){
				$('span.allow_delete_ticket_waiting_'+user_id).hide();
			}			
		});
		return false;
	});	
	$('form#welcome_to').submit(function(){
		var data_form = $(this).serialize();
		jQuery.ajax({
			type:'POST',
			url:wpo_ticket_ajax_url,
			data:data_form,
			beforeSend:function(){
				$('form#welcome_to button[type="submit"]').text('Wait for a moment!');
				$('div.progress').show();
				$('div.progress div.bar').width('20%');				
			},
			success:function(data){
				var data = $.parseJSON(data);
				if(data.resp=='success'){
					$('div.progress div.bar').width('100%');	
					$('form#welcome_to button[type="submit"]').text('Processing ...');
					window.location.href=data.url_ticket;
				}
				else{
					$('div.progress div.bar').width('0%');	
					$('div.progress').hide();
					$('form#welcome_to button[type="submit"]').text('Built now!');
					alert(data.mess);
				}
			}
		});
		return false;
	});
	$('button#ignore-settings').click(function(){
		if(confirm('[Warm] Ignore this action may be setting wrong!\nAre you sure?')){
			jQuery.ajax({
				type:'POST',
				url:wpo_ticket_ajax_url,
				data:'action=ignore_settings&ignore=true',
				success:function(data){
					var data = $.parseJSON(data);
					if(data.resp=='success'){
						window.location.href=data.url;
					}
				}
			});
			return false;			
		}
	});
	$('form#ticket_save_settings').submit(function(){
		var data_form = $(this).serialize();
		jQuery.ajax({
			type:'POST',
			url:wpo_ticket_ajax_url,
			data:data_form,
			beforeSend:function(){
				$('form#ticket_save_settings button[type="submit"]').text(' ... ');
			},
			success:function(data){
				var data = $.parseJSON(data);
				if(data.resp=='success'){
					$('form#ticket_save_settings button[type="submit"]').text(' Saved ');
				}
				else{
					alert(data.mess);
					$('form#ticket_save_settings button[type="submit"]').text('Save settings');
				}
					
			}			
		});
		return false;
	});
	$('form#issue_report').submit(function(){
		var data_form = $(this).serialize();
		jQuery.ajax({
			type:'POST',
			url:wpo_ticket_ajax_url,
			data:data_form,
			beforeSend:function(){
				$('form#issue_report button[type="submit"]').text('Sending ...');			
			},
			success:function(data){
				var data = $.parseJSON(data);
				alert(data.mess);
				$('form#issue_report button[type="submit"]').text('Send');	
			}			
		});
		return false;
	});
	$('button.loadmore').live("click",function(e){
		var post_id = $(this).attr('post_id');
		var trclass = $(this).attr('trclass');
		jQuery.ajax({
			type:'POST',
			url:wpo_ticket_ajax_url,
			data:'action=loadmore&post_id='+post_id+'&trclass='+trclass,
			beforeSend:function(){
				$('button.loadmore').attr("disabled", "disabled");
				$('button.loadmore').text('Loading ...');
			},
			success:function(data){
				var data = $.parseJSON(data);
				$('button.loadmore').text('Load more');
				$("table.grid-tickets tbody").append(data.data);
				if(data.post_id>0){
					$('button.loadmore').attr('post_id', data.post_id);
					$('button.loadmore').attr('trclass', data.trclass);
					$('button.loadmore').show();
					$('button.loadmore').removeAttr("disabled");
				}
				else{
					$('button.loadmore').hide();
				}
			}
		});
		return false;
	});
	$('form#ticket_loginform').submit(function(){
		var data_form = $(this).serialize();
		jQuery.ajax({
			type:'POST',
			url:wpo_ticket_ajax_url,
			data:data_form,
			beforeSend:function(){
				$('div.alert').hide();
				$('form#ticket_loginform button[type="submit"]').text('Checking ...');
			},
			success:function(data){
				var data = $.parseJSON(data);
				if(data.resp=='success'){
					window.location.href=data.url;
				}
				else{
					$('div.alert').show();
					$('div.alert').html(data.mess);
				}
				$('form#ticket_loginform button[type="submit"]').text('Sign In');
			}			
		});
		return false;		
	});
	$('button.debugme').click(function(){
		var thisme = $('button.debugme');
		jQuery.ajax({
			type:'POST',
			url:wpo_ticket_ajax_url,
			data:'action=debug&debug=true',
			beforeSend:function(){
				$('div.alert').remove();
				thisme.text(' .... ');
			},
			success:function(data){
				var data = $.parseJSON(data);
				var message = '<div class="alert debug-result '+data.resp+'">'+ data.mess+'</div>';
				$('div#result').append(message);
				thisme.text('Press Me Now!');
			}
		});
		return false;
	});
});