<?php
if( !defined('ABSPATH') )
	exit();
if( !class_exists('WPO_pressticket_API_KEY') ){
	class WPO_pressticket_API_KEY {
		var $APIKEY = 'pressticket_api_key';
		var $APIKEY_LENGTH = 15;
		function __construct() {
			add_action('init', array($this,'register_apikey_admin'));
			add_action('user_register', array($this,'register_apikey'),10,1);
		}
		function register_secretkey() {
			return $secret_key = json_encode( get_bloginfo('url') . rand(1000, 9999) );
		}
		function register_apikey_admin(){
			$action = isset( $_GET['action'] ) ? $_GET['action'] : null;
			$user_id = isset( $_GET['user_id'] ) ? (int)$_GET['user_id'] : null;
			$user = get_user_by('id', $user_id);
			if( is_admin() && current_user_can( 'add_users' ) && $action=='create_apikey' && username_exists( $user->user_login ) ){
				return $this->reset_apikey( $user_id );
			}
			return;
		}
		function register_apikey($user_id){
			if( !$user_id )
				return;
			$user = get_user_by('id', $user_id);
			if( !username_exists( $user->user_login ) )
				return;
			$apikey = md5( json_encode( $user ) . $this->register_secretkey() );
			$apikey = substr($apikey, 0, $this->APIKEY_LENGTH) ;
			return $this->save_apikey($user_id, $apikey);
		}
		function save_apikey($user_id, $apikey){
			do_action('pressticket_save_apikey', $user_id, $apikey);
			return update_user_meta($user_id, $this->APIKEY, $apikey);
		}
		function get_apikey($user_id){
			return get_user_meta($user_id,$this->APIKEY,true);
		}
		function delete_apikey($user_id){
			return delete_user_meta($user_id, $this->APIKEY);
		}
		function reset_apikey($user_id){
			$this->delete_apikey($user_id);
			return $this->register_apikey($user_id);
		}
	}
	$API_KEY = new WPO_pressticket_API_KEY();
}