<?php
if( !defined('ABSPATH') )
	exit();
if( !class_exists('WPO_pressticket_Shortcode') ){
	class WPO_pressticket_Shortcode {
		var $ticket_showatmost = 10;
		function __construct(){
			add_action('init', array($this,'add_shortcodes'));
		}
		function add_shortcodes() {
			add_shortcode('createticket', array($this,'createticket'));
			add_shortcode('user_tickets', array($this,'user_tickets'));
			add_shortcode('user_quicktickets', array($this,'user_quicktickets'));
		}
		function createticket($attr = NULL, $content = NULL){
			global $post;
			$envato_support = ( trim( $attr['envato'] )=='yes' ) ? true : false;
			$post->ID = NULL;
			$html = NULL;
			$selector = $attr['selector'] ? (int)$attr['selector'] : null;
			if( wpo_ticket_option_helpdesk_status()=='yes' ):
			if(current_user_can( wpo_ticket_cap_view_ticket() )):
			$html .= '<form class="ticket-form press-ticket-form-frontend" name="createticket" id="createticket" action="" method="post">
			  <div class="control-group department">
			    <label class="control-label" for="'.__('Department','wpo').'">'.__('Department','wpo').'</label>';
			$html .= '
			    <div class="controls">';
			      	$terms = get_terms('department', array(
			      		'hide_empty'	=>	false
			      	));
			      	if($terms){
			      		$html .= '<select name="department" class="regular-text department">';
			      			$html .= '<option value="">'.__('Choose a Department','wpo').'</option>';
			      			foreach ($terms as $term){
			      				$html .= '<option value="'.$term->term_id.'">'.$term->name.'</option>';
			      			}
			      		$html .=  '</select>';
			      		$html .= '<div><img style="display:none;" id="icon_loading" src="'.WPO_PRESSTICKET_PLUGIN_URL.'assets/img/loading.gif"></div>';
			      	}
			      	else{
			      		$html .= '
							<div class="alert">
								'.sprintf( __('<strong>Warning!</strong> Need to create %s','wpo'), '<a href="'.admin_url('edit-tags.php?taxonomy=department&post_type=wp-ticket').'">'.__('Department','wpo').'</a>' ).'
							</div>
			      		';
			      	}
				$html .= '
			    </div>
			  </div>';
			  $prioritys = wpo_ticket_get_priority_options();
			  if($prioritys){
			  	$html .= '
				  	<div class="control-group">
					    <label class="control-label">'.__('Priority','wpo').'</label>
					    <div class="controls">		  	
			  	';
		      		$html .= '<select class="priority regular-text" name="priority">';
		      			foreach ($prioritys as $k=>$v){
		      				$html .= '<option value="'.$k.'">'.$v.'</option>'; 
		      			}
		      		$html .= '</select>';
				  $html .= '
				    </div>
				  </div>';
		      }
		      $status = wpo_ticket_get_status_options();
		      if( is_array( $status ) ){
				  $html .='
				  <div class="control-group">
				    <label class="control-label" for="Priority">'.__('Status','wpo').'</label>
				    <div class="controls">
						<select class="status regular-text" name="status">';
		      				foreach ($status as $k=>$v ){
								$html .= '<option value="'.$k.'">'.$v.'</option>';
							}			  
					$html .= '</select>
				    </div>
				  </div>';
		      }	  
		      $html .= '
			  <div class="control-group">
			    <label class="control-label" for="'.__('Subject: Issue summary  * ').'">'.__('Subject: Issue summary  * ').'</label>
			    <div class="controls">
			      <input name="subject" class="input-xxlarge regular-text" type="text" id="Subject" placeholder="'.__('Subject: Issue summary  * ','wpo').'">
			    </div>
			  </div>';
			if( WPO_pressticket_woocommerce::check_woocommerce_installed()===true && wpo_ticket_option_ticket_woo_enable()=='yes'){
				### Woocommerce installed
				$html .= '
				  <div class="control-group">
				    <label class="control-label" for="'.__('Related product ').'">'.__('Related product ').'</label>
				    <div class="controls">
				    	'.WPO_pressticket_woocommerce::get_products($selector).'
				    </div>
				  </div>	
				';
			}
			if( wpo_ticket_option_envato_enable()=='yes' && wpo_ticket_option_envato_username()!='' && wpo_ticket_option_envato_api()!='' )
			$html .= '
			  <div class="control-group">
			    <label class="control-label" for="'.__('Envato Purchase Key','wpo').'">'.__('Envato Purchase Key','wpo').'</label>
			    <div class="controls">
			    	<input name="envato_purchase_key" class="input-xxlarge regular-text" type="text" id="envato_purchase_key" placeholder="'.__('Envato Purchase Key','wpo').'">
			    </div>
			  </div>
			  <div class="control-group">
			    <label class="control-label" for="'.__('Envato Account','wpo').'">'.__('Envato Account','wpo').'</label>
			    <div class="controls">
			    	<input name="envato_account" class="input-xxlarge regular-text" type="text" id="envato_account" placeholder="'.__('Envato Account','wpo').'">
			    </div>
			  </div>				  	
			';	
			$html .= '
			  <div class="control-group">
			    <label class="control-label">'.__('Issue: Details on the reason(s) for opening the ticket. * ','wpo').'</label>
			    <div class="controls">
			    	'.wpo_ticket_get_editor('', 'post_content', 'post_content').'
			    </div>
			  </div>';
			  if( wpo_ticket_check_enable_recaptcha()===true && function_exists('recaptcha_get_html') ):
			  $html .= '<div class="control-group">
			    <div class="controls">
			    	'.recaptcha_get_html(wpo_ticket_option_recaptcha_publish_key(), $error).'
			    </div>
			  </div>';
			  endif;		  
			  $html .= '<div class="control-group">
			    <div class="controls">';
				  if( wpo_ticket_option_envato_enable()=='yes' ){
				  	$html .= '<input type="hidden" name="envato_purchasekey" value="required">';
				  }
			  	$html .= '
			      <input type="hidden" name="action" value="createticket">
			      <button type="submit" class="btn btn-large" >'.__('Open Ticket','wpo').'</button>
			    </div>
			  </div>
			</form>	
			<div class="alert" style="display: none;"></div>';
			else:
				if(!get_current_user_id() && wpo_ticket_option_show_loginform_createticket()=='yes'):
					$html .= '<div style="display: none" class="alert"></div>'.wpo_ticket_get_loginform();
				else:
					$html .=  '<div class="alert alert-error">';
					  $html .=  __('You do not have sufficient permissions to access this page','wpo');
					$html .=  '</div>';
				endif;
			endif;
			else:
				$html .= '<div class="alert alert-error">';
				  $html .= wpo_ticket_option_helpdesk_status_messages();
				$html .= '</div>';		
			endif;
			return $html;
		}
		function user_tickets($args=NULL, $content = NULL) { 
			$html = null;
			if( wpo_ticket_option_helpdesk_status()=='yes' ):
			if( current_user_can( wpo_ticket_cap_view_ticket() )):
			$user = get_current_user_id();
			$html ='
				<div class="create-new">
					<button onclick="window.location.href=\''.wpo_ticket_get_url_createticket().'\'" class="btn btn-large press-ticket-form-frontend-button" type="button">'.__('Create new ticket','wpo').'</button>
				</div>
					  <div class="tab-pane active" id="tickets">
					    <form action="" method="get" class="press-ticket-frontend-search-form press-ticket-form-frontend">
							<div class="input-append">
							  <input class="span2" name="keyword" type="text" placeholder="'.__('Keyword or #ticket ID','wpo').'" value="'. trim($_GET['keyword']).'">
							  <input type="submit" style="margin-top: 0px;" class="btn" value="'.__('Go!','wpo').'">
							  '.wp_nonce_field('ticket_search_act','ticket_search',false).'
							</div>				    
					    </form>';
							$args = array(
								'post_type'	=>	'wp-ticket',
								'author'	=>	$user,
								'showposts'	=>	$this->ticket_showatmost,
								'orderby'	=>	'ID',
								'order'	=>	'DESC'
							);
							### OR meta
							if(trim($_GET['keyword'])){
								$ticket_id = trim($_GET['keyword']);
								$args['meta_query'] = array(
									array(
										'key'	=>	'wpo_ticket_ID',
										'value'	=>	$ticket_id,
										'compare'	=>	'='								
									)
								);
							}
							add_filter('posts_where', 'wpo_ticket_pre_search_myticket');
							query_posts($args);
							remove_filter('posts_where', 'wpo_ticket_pre_search_myticket');
							if(have_posts()):
							if($_GET['keyword']){
								$keyword = '?keyword='.trim($_GET['keyword']);	
							}
							$html .= apply_filters('pressticket_before_ticketlist', null);
							$html .='								
							<table class="table table-hover grid-tickets press-ticket-table-frontend">
								<thead>
					                <tr>
					                  <td>'.__('#ID','wpo').'</td>
					                  <td>'.__('Status','wpo').'</td>
					                  <td>'.__('Issue','wpo').'</td>
					                  <td>'.__('Department','wpo').'</td>
					                  <td>'.__('Help Topic','wpo').'</td>
					                  <td style="width: 10%">'.__('Date','wpo').'</td>
					                  <td>'.__('Prioritys','wpo').'</td>
					                </tr>
				              	</thead><tbody>';
							$j=0;
							while (have_posts()):the_post();
								$j++;
								$trclass = ( $j%2!=0 ) ? 'first' : 'last';
								$lastest_post = get_the_ID();
								### check woo installed && enable woo support function
								if( WPO_pressticket_woocommerce::check_woocommerce_installed()===true && wpo_ticket_option_ticket_woo_enable()=='yes'){
									if( get_post_meta(get_the_ID(),'wpo_ticket_related_product',true) > 0 ){
										$related_product = __('Related: ','wpo') . '<a href="'.get_permalink( get_post_meta(get_the_ID(),'wpo_ticket_related_product',true) ) .'">' . get_the_title( get_post_meta(get_the_ID(),'wpo_ticket_related_product',true) ) . '</a>';	
									}
									else{
										$related_product = NULL;
									}
								}
	
								$helptopic = get_post_meta(get_the_ID(),'wpo_ticket_helptopics',true) ? '<span class="label">'. get_post_meta(get_the_ID(),'wpo_ticket_helptopics',true) .'</span>' : NULL;
								$html .='	
					                <tr id="'.$lastest_post .'" class="'.$trclass.'">
					                  <td>'.wpo_ticket_get_ticketID(get_the_ID()).'</td>
					                  <td>'.wpo_ticket_hightlight_status( wpo_ticket_get_ticket_status(get_the_ID(),true)).'</td>
					                  <td><h3><a href="'. get_permalink() . $keyword .'">'.get_the_title(). '</a></h3>'.$related_product.'</td>
					                  <td>'; 
										$terms = wp_get_post_terms( get_the_ID(), 'department', $args );	
										$html .='<div class="department">'. $terms[0]->name .'</div>';
									$html .='			                  
					                  </td>
					                  <td>'.$helptopic.'</td>
					                  <td>'.get_the_date().'</td>
					                  <td>'. wpo_ticket_hightlight_priority( wpo_ticket_get_ticket_priority(get_the_ID(),true) ).'</td>
					                </tr>';
							endwhile;
							$html .= '
							</tbody></table>
								<button trclass="'.$j.'" post_id='.$lastest_post.' class="btn btn-large btn-block loadmore press-ticket-frontend-loadmore press-ticket-form-frontend-button" type="button">'.__('Load more','wpo').'</button>';
							else:
							$html .= '
							<div class="alert alert-block">
								'.__('Nothing!','wpo').'
							</div>';
							endif;
							wp_reset_query();
						$html .= '				
					    </div>			    
					  </div>';
			else:
				if(!get_current_user_id() && wpo_ticket_option_show_loginform_mytickets()=='yes'):
					$html .= '<div style="display: none" class="alert"></div>' . wpo_ticket_get_loginform();	
					
				else:
					$html .= '<div class="alert alert-error">';
					  $html .= __('You do not have sufficient permissions to access this page','wpo');
					$html .= '</div>';			
				endif;
			endif;
			else:
				$html .= '<div class="alert alert-error">';
				  $html .= wpo_ticket_option_helpdesk_status_messages();
				$html .= '</div>';		
			endif;	
			return $html;	
		}
		function user_quicktickets($args=NULL, $content = NULL){
			global $wpdb;
			$user_id = get_current_user_id();
			if(!$user_id) return;
			$show = $args['show'] ? $args['show'] : 5; 
			$status = $args['status'] ? $args['status'] : NULL;
			$priorities = $args['priority'] ? $args['priority'] : NULL;
			$class = $args['class'] ? $args['class'] : null;
			$format = $args['format'] ? $args['format'] : 'html'; 
			$where = "
				`post_type`='wp-ticket'
				 AND `post_status`='publish'
				 AND `post_author` = $user_id
			";
			if($status!=NULL){
				$where .= " OR ( pm.meta_key='wpo_ticket_status' AND pm.meta_value='$status' )";
			}
			if($priorities!=NULL){
				$where .= " OR ( pm.meta_key='wpo_ticket_priority' AND pm.meta_value='$priorities' )";
			}
			$sql = "
				SELECT * FROM $wpdb->posts p
				INNER JOIN $wpdb->postmeta pm
					ON p.ID = pm.post_id
				WHERE $where
				group by p.ID order by p.post_modified desc
				LIMIT $show
			";
			//exit($sql);
			$query = $wpdb->get_results($sql, ARRAY_A);
			if($format == 'html'){
				if(is_array($query)){
					$html = '<ul class="quick-tickets '.$class.'">';
						foreach ($query as $tickets){
							$html .= '<li><h4><span class="label">'.wpo_ticket_get_ticketID( $tickets[ID] ).'</span> <a href="'.get_permalink($tickets[ID]).'">'.$tickets['post_title'].'</a></h4></li>';
						}
					$html .= '</ul.';
				
				}
				return $html;			
			}
			else return $query;
		}		
	}
	$WPO_pressticket_Shortcode = new WPO_pressticket_Shortcode();
}