<?php
/**
 * Available in Version 2.3.1
 */
if( !defined('ABSPATH') )
	exit();
if( !class_exists('WPO_pressticket_RepairMetafields') ){
	class WPO_pressticket_RepairMetafields {
		function __construct(){
			add_action('wp', array($this,'update_ticket_priority'));
			add_action('wp', array($this,'update_ticket_status'));
		}
		function update_ticket_priority(){
			global $post;
			if( get_post_type($post) =='wp-ticket' ){
				if( !get_post_meta($post->ID,'wpo_ticket_priority',true) ){
					update_post_meta($post->ID, 'wpo_ticket_priority', 'normal');
				}				
			}
		}
		function update_ticket_status(){
			global $post;
			if( get_post_type($post) =='wp-ticket' ){
				if( !get_post_meta($post->ID,'wpo_ticket_status',true) ){
					update_post_meta($post->ID, 'wpo_ticket_status', 'open');
				}				
			}
		}		
	}
	$WPO_pressticket_RepairMetafields = new WPO_pressticket_RepairMetafields();
}