<?php
if( !defined('ABSPATH') )
	exit();
?>
<h2><?php _e('Alerts and Notices (Alerts and Notices sent to staff on ticket "events")','wpo');?></h2>
<?php 
	$yesno = wpo_ticket_yesno();
?>
<form name="ticket_save_settings" id="ticket_save_settings" action="" method="post">
<table class="form-table">
	<tbody>
		<tr valign="top"><td colspan="2"><h3><?php _e('Alerts and Notices (Alerts and Notices sent to staff on ticket "events")','wpo');?></h3></td></tr>
		<tr>
			<th scope="row"><?php _e('<strong>New Ticket Alert:</strong> Alert sent out on new tickets','wpo');?></td>
			<td>
				<select class="regular-text" name="wpo_ticket_option_alert_new_tickets">
				<?php 
					foreach ($yesno as $k=>$v){
						?>
							<option <?php if( wpo_ticket_option_alert_new_tickets()==$k ): echo 'selected';endif;?> value="<?php echo $k;?>"><?php echo $v;?></option>
						<?php 
					}
				?>
				</select>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row"><?php _e('<strong>New Message Alert:</strong> Alert sent out when a new message, from the user, is appended to an existing ticket','wpo');?></td>
			<td>
				<select class="regular-text" name="wpo_ticket_option_alert_new_messages">
				<?php 
					foreach ($yesno as $k=>$v){
						?>
							<option <?php if( wpo_ticket_option_alert_new_messages()==$k ): echo 'selected';endif;?> value="<?php echo $k;?>"><?php echo $v;?></option>
						<?php 
					}
				?>
				</select>
			</td>
		</tr>
		<tr valign="top"><td colspan="2">
			<input type="hidden" name="action" value="ticket_save_settings">
			<button type="submit" class="button button-primary button-large" type="button"><?php _e('Save settings','wpo');?></button>
		</td></tr>
	</tbody>
</table>
</form>