<?php
if( !defined('ABSPATH') )
	exit();
?>
<h2><?php _e('Email templates','wpo');?></h2>
<?php 
	$yesno = wpo_ticket_yesno();
?>
<?php 
	$shortcode = array(
		'{ticket.number}'	=>	__('Display Ticket Number, eg: #9f7a624','wpo'),
		'{ticket.name}'	=>	__('Display Ticket name/title','wpo'),
		'{ticket.email}'	=>	__('Display email address of Ticker, who open the ticket','wpo'),
		'{ticket.dept.name}'	=>	__('Display Department name','wpo'),
		'{message}'	=>	__('Display ticket content','wpo'),
		'{ticket.staff_link}'	=>	sprintf( __('Display ticket detail url, eg: %s') , get_bloginfo('url') .'/'. wpo_ticket_option_slug() . '/this-is-a-ticket' ),
		'{response}'	=>	__('This is the Response Content of the Ticket, which is written by Helpdesk Staff.','wpo'),
		'{signature}'	=>	__('Display HelpDesk name','wpo')
	)
?>
<form name="ticket_save_settings" id="ticket_save_settings" action="" method="post">
<table class="form-table">
	<tbody>
		<tr valign="top"><th scope="row" colspan="2"><h3><?php _e('Email templates','wpo'); ?></h3></td></tr>
		<tr valign="top">
			<th scope="row"><?php _e('<strong>New Ticket Alert</strong> - Alert sent to staff, if enabled, on new ticket.','wpo');?></td>
			<td>
				<?php print wpo_ticket_get_editor(nl2br( wpo_ticket_get_mail_new_ticket_alert() ), 'wpo_ticket_get_mail_new_ticket_alert', 'wpo_ticket_get_mail_new_ticket_alert',false);?>
				<div class="shortcode">
				<?php 
					foreach ($shortcode as $key=>$value){
						if( $key!='{response}' && $key!='{signature}' ){
							echo '<code>' . $key . '</code>';
						}
					}
				?>
				</div>
			</td>
		</tr>	
		<tr valign="top">
			<th scope="row"><?php _e('<strong>New Message Alert</strong> - Alert sent to staff, if enabled, when the user reply to an existing ticket.','wpo');?></td>
			<td>
				<?php print wpo_ticket_get_editor(nl2br( wpo_ticket_get_mail_new_ticket_messages() ), 'wpo_ticket_get_mail_new_ticket_messages', 'wpo_ticket_get_mail_new_ticket_messages',false);?>
				<div class="shortcode">
				<?php 
					foreach ($shortcode as $key=>$value){
						if( $key!='{response}' && $key!='{signature}' ){
							echo '<code>' . $key . '</code>';
						}
					}
				?>
				</div>				
			</td>
		</tr>
		<tr valign="top">
			<th scope="row"><?php _e('<strong>Response/Reply Template</strong> - Template used on ticket response/reply.','wpo');?></td>
			<td>
				<?php print wpo_ticket_get_editor(nl2br( wpo_ticket_get_mail_response() ), 'wpo_ticket_get_mail_response', 'wpo_ticket_get_mail_response',false);?>
				<div class="shortcode">
				<?php 
					foreach ($shortcode as $key=>$value){
						if( $key!='{ticket.number}' && $key!='{ticket.email}' && $key!='{ticket.dept.name}' && $key!='{message}' ){
							echo '<code>' . $key . '</code>';
						}
					}
				?>
				</div>				
			</td>
		</tr>
		<tr valign="top">
			<th scope="row"><?php _e('Shortcode:','wpo')?></th>
			<td>
				<div class="shortcode">
					<?php 
						foreach ($shortcode as $key=>$value){
							echo '<code>'.$key.'</code><i>' . $value . '<i><br/>';
						}
					?>
					
					
				</div>		
			</td>
		</tr>
		<tr valign="top"><td colspan="2">
			<input type="hidden" name="action" value="ticket_save_settings">
			<button type="submit" class="button button-primary button-large" type="button"><?php _e('Save settings','wpo');?></button>
		</td></tr>
	</tbody>
</table>

</form>